/<template>
  <div class="container">
    <!-- <background /> -->
    <div class="title">
      <img src="../assets/logo.png" alt="" />
      <span>surong_dan</span>
    </div>
    <div class="register-box">
      <el-form
        :model="loginForm"
        ref="loginForm"
        status-icon
        :rules="loginRules"
        label-width="80px"
        label-position="left"
      >
        <el-form-item prop="username" label="用户名">
          <div style="display: flex">
            <el-input
              v-model="loginForm.username"
              placeholder="请输入用户名"
              @keyup.enter.native="handleRegister"
              auto-complete="off"
            >
              <i
                slot="prefix"
                class="el-input__icon el-icon-s-custom"
                style="font-size: 20px"
              ></i>
            </el-input>
          </div>
        </el-form-item>
        <el-form-item prop="email" label="邮箱">
          <div style="display: flex">
            <el-input
              v-model="loginForm.email"
              placeholder="请输入邮箱"
              @keyup.enter.native="handleRegister"
              auto-complete="off"
            >
              <i
                slot="prefix"
                class="el-input__icon el-icon-s-platform"
                style="font-size: 20px"
              ></i>
            </el-input>
          </div>
        </el-form-item>
        <el-form-item prop="password" label="密码">
          <el-input
            placeholder="请输入密码"
            @keyup.enter.native="handleRegister"
            :type="passwordType"
            v-model="loginForm.password"
            auto-complete="off"
          >
            <i
              class="el-input__icon el-icon-view"
              :style="fontstyle"
              slot="suffix"
              style="font-size: 20px"
              @click="showPassword"
            >
            </i>
            <i
              slot="prefix"
              style="font-size: 20px"
              class="el-input__icon el-icon-lock"
            >
            </i>
          </el-input>
        </el-form-item>
        <el-form-item prop="repassword" label="确认密码">
          <el-input
            v-model="loginForm.repassword"
            placeholder="请再次输入密码"
            @keyup.enter.native="handleRegister"
            auto-complete="off"
            :type="passwordType"
          >
            <i
              slot="prefix"
              style="font-size: 20px"
              class="el-input__icon el-icon-lock"
            >
            </i>
          </el-input>
        </el-form-item>
        <div class="verifycode">
          <el-form-item prop="verifycode" label="验证码">
            <!-- 注意：prop与input绑定的值一定要一致，否则验证规则中的value会报undefined，因为value即为绑定的input输入值 -->
            <el-input
              v-model="loginForm.verifycode"
              placeholder="请输入验证码"
              class="identifyinput"
            >
              <i
                slot="prefix"
                class="el-input__icon el-icon-s-check"
                style="font-size: 22px"
              >
              </i>
            </el-input>
          </el-form-item>
          <el-button
            plain
            :disabled="verifyButtonDisable"
            @click="getVerifycode"
            >{{ verifyButtonContent }}</el-button
          >
        </div>
        <el-form-item label-width="0px" class="submitbutton">
          <el-button
            type="primary"
            @click.native.prevent="handleRegister"
            class="login-submit"
            >注册</el-button
          >
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>
<script>
// import SIdentify from "../components/identify.vue";
import { reqRegister, reqVerified } from "@/api";
import background from "@/components/background";
export default {
  name: "CertificateLogin",
  data() {
    // 用户名自定义验证规则
    const validateUsername = (rule, value, callback) => {
      if (!value) {
        callback(new Error("请输入正确的用户名"));
      } else {
        console.log("user", value);
        callback();
      }
    };
    // 邮箱自定义验证规则
    const validateEmail = (rule, value, callback) => {
      const reg = /^[a-zA-Z0-9_-]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$/;
      if (!reg.test(value)) {
        callback(new Error("请输入正确的邮箱"));
      } else {
        console.log("email", value);
        callback();
      }
    };
    // 确认密码验证规则
    const validateRepassword = (rule, value, callback) => {
      if (!value) callback(new Error("尚未确认密码"));
      else if (value !== this.loginForm.password) {
        callback(new Error("两次输入密码不一致"));
      } else {
        console.log("repasswd", value);
        callback();
      }
    };
    // 验证码自定义验证规则
    const validateVerifycode = (rule, value, callback) => {
      if (!value) {
        callback(new Error("请输入验证码"));
      } else {
        callback();
      }
    };
    return {
      // show: false,
      activeIndex: "1",
      dialogVisible: false,
      fontstyle: {
        color: "gray",
      },
      loginForm: {
        username: "",
        email: "",
        password: "",
        repassword: "",
        verifycode: "",
      },
      checked: false,
      loginRules: {
        // 绑定在form表单中的验证规则
        username: [
          { required: true, trigger: "blur", validator: validateUsername },
        ],
        email: [{ required: true, trigger: "blur", validator: validateEmail }],
        password: [
          { required: true, message: "请输入密码", trigger: "blur" },
          { min: 6, message: "密码长度最少为6位", trigger: "blur" },
        ],
        repassword: [
          { required: true, trigger: "blur", validator: validateRepassword },
        ],
        verifycode: [
          { required: true, trigger: "blur", validator: validateVerifycode },
        ],
      },
      passwordType: "password",
      verifyButtonContent: "获取验证码",
      verifyButtonDisable: false,
    };
  },
  components: {
    // SIdentify
    background,
  },
  created() {},
  mounted() {},
  filters: {
    checkChange(formName) {
      if (this.checked === true) {
        this.loginForm.username = "admin";
        this.loginForm.password = "111111";
        this.loginForm.verifycode = "";
      } else {
        this.$nextTick(() => {
          this.$refs[formName].resetFields();
        });
      }
    },
  },
  computed: {},
  props: [],
  methods: {
    getPhoto() {},
    // 通过改变input的type使密码可见
    showPassword() {
      this.fontstyle.color === "gray"
        ? (this.fontstyle.color = "blue")
        : (this.fontstyle.color = "gray"); // 改变密码可见按钮颜色
      this.passwordType === ""
        ? (this.passwordType = "password")
        : (this.passwordType = "");
    },
    // 点击注册
    handleRegister() {
      console.log("点击了登录");
      this.$refs.loginForm.validate((valid) => {
        if (valid) {
          // console.log(this.loginForm)
          reqRegister({
            user_name: this.loginForm.username,
            user_email: this.loginForm.email,
            user_pwd: this.loginForm.password,
            user_verify: this.loginForm.verifycode,
          })
            .then((res) => {
              console.log("正确返回", res);
              this.$router.replace("/login");
            })
            .catch((err) => {
              console.log("错误返回", err);
            });
        }
      });
    },
    getVerifycode() {
      console.log("email", this.loginForm.email);
      // 发送axios请求,让后台发邮件
      reqVerified({
        user_email: this.loginForm.email,
      });
      // 设置按钮禁用
      let time = 60;
      this.verifyButtonContent = time + "s";
      this.verifyButtonDisable = true;
      let timer = setInterval(() => {
        --time;
        if (time === 0) {
          clearInterval(timer);
          this.verifyButtonContent = "获取验证码";
          this.verifyButtonDisable = false;
        } else this.verifyButtonContent = time + " s";
      }, 1000);
    },
  },
};
</script>

<style scoped lang="scss">
.container {
  .title {
    user-select: none;
    display: flex;
    justify-content: center;
    align-items: center;
    min-height: 80px;
    height: 20vh;
    img {
      height: 70px;
    }
    span {
      font-size: 3rem;
      margin-left: 10px;
    }
  }
  .register-box {
    width: 420px;
    height: 420px;
    box-sizing: border-box;
    border-radius: 10px;
    box-shadow: 0 0 20px #ccc;
    background: rgba($color: #fff, $alpha: 0.2);
    margin: 0 auto;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    position: relative;
    el-form {
      position: relative;
      z-index: 1;
    }
    .identifybox {
      display: flex;
      justify-content: space-between;
      margin-top: 7px;
    }
    .iconstyle {
      color: #409eff;
    }
    .login-submit {
      width: 100px;
    }
    .submitbutton {
      display: flex;
      justify-content: center;
      margin: 0;
    }
    el-input {
      display: inline-block;
    }
    .logo {
      height: 150px;
      width: 100%;
    }
    .verifycode {
      display: flex;
      justify-content: space-between;
      width: 370px;
      button {
        height: 100%;
        margin: 0 0 0 10px;
        width: 8em;
        text-align: center;
        padding-left: 0;
        padding-right: 0;
      }
    }
  }
}
</style>
